 Member

   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('JSWIDGET.INC'),ONCE


WidgetClass.AddFEQ             Procedure(Long pOriginalFEQ,Long pNewFEQ)!,Byte,Proc

  Code

  If NOT pOriginalFEQ OR NOT pNewFEQ
    Return 0
  end
  If Self.FetchFEQ(pNewFEQ) > 0
    Delete(Self.FEQQ)
  end
  Self.FEQQ.OriginalFEQ = pOriginalFEQ
  Self.FEQQ.NewFEQ      = pNewFEQ
  Add(Self.FEQQ)
  Return 1


WidgetClass.Clone              Procedure(Window pTarget,Long pParentFEQ=0,<Long pXPos>,<Long pYPos>)!,Byte,Proc

Omit:pXPos Equate(4)
Omit:pYPos Equate(5)

OrigX    Long
OrigY    Long
FEQNewX  Long
FEQNewY  Long

Ndx      Long
FEQ      Long

FEQQ    Queue
FEQ       Long
ParentFEQ Long
X         Long
Y         Long
W         Long
H         Long
        end

  Code

   Self.W &= System{PROP:Target}
   Free(FEQQ)
   Loop Ndx = FirstField() to LastField()
     FEQQ.FEQ = Ndx
     FEQQ.ParentFEQ = Ndx{PROP:Parent}
     GetPosition(Ndx,FEQQ.X,FEQQ.Y,FEQQ.W,FEQQ.H)
     Add(FEQQ)
   end
   SetTarget(pTarget)
   GetPosition(pParentFEQ,OrigX,OrigY)
   Loop Ndx = 1 to Records(FEQQ)
     Get(FEQQ,Ndx)
     If FEQQ.ParentFEQ
       FEQ = Clone(0,FEQQ.FEQ,Self.FetchFEQ(FEQQ.ParentFEQ,1),,Self.W)
     else
       FEQ = Clone(0,FEQQ.FEQ,pParentFEQ,,Self.W)
     end
     FEQ{PROP:Use} = (FEQQ.FEQ{PROP:UseAddress})
     If Omitted(Omit:pXPos)
       FEQNewX = FEQQ.X 
     else
       FEQNewX = FEQQ.X + pXPos + OrigX
     end
     If Omitted(Omit:pYPos)
       FEQNewY = FEQQ.Y 
     else
       FEQNewY = FEQQ.Y + pYPos + OrigY
     end
     SetPosition(FEQ,FEQNewX,FEQNewY,FEQQ.W,FEQQ.H)
     Self.AddFEQ(FEQQ.FEQ,FEQ)
   end
   SetTarget
   Return 0


WidgetClass.Construct          Procedure

  Code

  Self.FEQQ &= NEW WidgetFEQQ
  Clear(Self.FEQQ)

WidgetClass.Destruct           Procedure

  Code

  If NOT Self.FEQQ &= NULL
    Dispose(Self.FEQQ)
  end

WidgetClass.FetchFEQ                Procedure(Long pFEQ,Byte pFEQType=0)!,Long

  Code

  Case pFEQType
  of 0
    Self.FEQQ.NewFEQ = pFEQ
    Get(Self.FEQQ,Self.FEQQ.NewFEQ)
    If ErrorCode()
      Return -1000
    end
    Return Self.FEQQ.OriginalFEQ
  end
  Self.FEQQ.OriginalFEQ = pFEQ
  Get(Self.FEQQ,Self.FEQQ.OriginalFEQ)
  If ErrorCode()
    Return -1000
  end
  Return Self.FEQQ.NewFEQ

WidgetMasterClass.Construct Procedure

  Code

  Self.Widgets &= NEW WidgetQ

WidgetMasterClass.Destruct Procedure

  Code

  If NOT Self.Widgets &= NULL
    Dispose(Self.Widgets)
  end

WidgetMasterClass.AddItem   Procedure(WidgetClass pWidget,Long pParentFEQ=0,<Long pXPos>,<Long pYPos>)!,Byte,Proc

   Code

  Assert(NOT SELF.W &= NULL,'SELF.W Not Initialized')

  Self.Widgets.Widget &= pWidget
  Add(Self.Widgets)
  Self.Widgets.Widget.Clone(SELF.W,pParentFEQ,pXPOS,pYPOS)

  Return 0

WidgetMasterClass.Init Procedure

  Code


WidgetMasterClass.TakeEvent Procedure
Ndx Long

  Code

  Loop Ndx = 1 to Records(Self.Widgets)
    Get(Self.Widgets,Ndx)
    Self.Widgets.Widget.TakeEvent
  end